<?php

require_once 'base/GpetpmovtransfmEntityBase.php';


/**
 * GpetpmovtransfmEntity.
 *
 * @package Entity
 * @author  alessandrobartels
 *
 */
class GpetpmovtransfmEntity extends GpeTpmovtransfmEntityBase
{

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;


    /**
     * Construtor.
     *
     * @param integer    $id             Identificador.
     * @param integer    $nrOrgPadrao    Numero da Org. Padrao.
     * @param integer    $nrOrg          Numero da Org. Trabalho.
     * @param TkDateTime $mesCompetencia Mes de competencia.
     */
    public function __construct($id= null, $nrOrgPadrao = null, $nrOrg = null, TkDateTime $mesCompetencia = null){
        parent::__construct($id);
        $this->_nrOrgPadrao = $nrOrgPadrao;
        $this->_nrOrg = $nrOrg;
        $this->_mesCompetencia = $mesCompetencia;
    }


    /**
     * Enter description here ...
     *
     * @param integer $nrTpMovTransf Numero do Tipo de Tranferencia.
     *
     * @return Ambigous <NULL, mixed>|NULL
     */
    public function retornaTpMovTransf($nrTpMovTransf){
        $tpMovTransf = Gpetpmovtransfm::retornaTipoMovimentacaoTransferencia(
            $this->_nrOrgPadrao, $this->_nrOrg, $nrTpMovTransf
        );
        if (is_object($tpMovTransf) === true) {
            // Retorna o historico mais atual, de acordo com a data.
            $historico = end(
                Gpetpmovtransfh::retornaTipoMovimentacaoTransferenciaHistorico($nrTpMovTransf, $this->_mesCompetencia)
            );

            $tpMovTransf->historico = $historico;
            return $tpMovTransf;
        } else {
            return null;
        }
    }


}