/* eslint-disable */
// @ts-nocheck
import { Metadata, Http, IDictionary } from '@zeedhi/core';
import { LoadingService, DialogService, GridEditable, Modal, ModalService, Form } from '@zeedhi/common';

export class ProdutosProcessadosController {

  private retiradaModal!: Modal;

  private masterCurrentRow: any = {};

  private selectProdutoCurrentRow: any = {};

  public currentRowSelected2 = false;

  private filiLancProdProcessa = null;

  public isInlineEditingMaster = false;

  private masterToolbar = [];

  private masterHeight = false;

  private paramFilialData: any = {};

  private detailStatus = { editing: false };

  private paramsNewCode = {
    __is_new_code: true,
    __new_code_pk: "LANCPROCESSA",
    __table_pk: "NRLANCPROCESSA",
    __using_unit: true,
    __new_code_length: 1,
    __new_code_column_size: 10,
    __columns_to_return: [
      "NRLANCPROCESSA",
      "CDFILIAL"
    ]
  };

  get produtosProcessadosGridHeight2() {
    return this.currentRowSelected2 ? 150 : '100%';
  }

  get filialLancamento() {
    return this.filiLancProdProcessa;
  }

  public setMasterFilter({ component }: IEventParam<any>) {
    const filialValue = component.value.CDFILIAL;
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');

    gridMaster.datasource.filter.CDFILIAL = filialValue;
    gridDetail.datasource.filter.CDFILIAL = filialValue;
    
    gridMaster.getColumn('CDPRODUTO').componentProps.datasource.filter.CDFILIAL = filialValue;
    
    Http.get('/paramfilial?in=CDFILIAL&CDFILIAL=' + filialValue).then((response) => {
      this.paramFilialData = response.data.data[0];
    });

    gridMaster.reload();
  }

  public reload({ component }: IDictionary) {
    const grid = this.returnGrid(component) as GridEditable;
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    if (grid.editing) this.defaultState(grid);
    if (gridDetail.editing) this.defaultState(gridDetail);

    this.detailStatus.editing = false;
    grid.selectedRows = [];
    return grid.reload();
  }

  public cancelEdit({ component }: any) {
    const grid = this.returnGrid(component) as GridEditable;
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    grid.newRow = false;
    grid.datasource.data = grid.datasource.data.filter((row) => !row.__is_new);
    grid.cancelEditedRows();
    grid.datasource.currentRow = {};
    if (gridDetail.editing) this.defaultState(gridDetail);
    this.detailStatus.editing = false;
  }

  public saveGrid({ component }: IDictionary) {
    const gridMaster = this.returnGrid(component) as GridEditable;
    const masterRow = gridMaster.datasource.currentRow;
    (gridMaster as any).editedRows[masterRow.NRLANCPROCESSA].originalRow = masterRow;
    const changedRowsMaster = gridMaster.getEditedRows();
    const isDataSetMaster = changedRowsMaster.length > 1;
    changedRowsMaster.forEach((row) => row.changed === true);
    this.setNewCodeField(changedRowsMaster);
    const params = isDataSetMaster ? changedRowsMaster : changedRowsMaster[0];
    try {
      let compQtLanc = gridMaster.getComponent(masterRow.NRLANCPROCESSA, 'QTLANCPROCESSA');
    } catch (err) {
      let compQtLanc = {};
      compQtLanc.value = null;
    }
    if (masterRow.VRTOTALLANC == 0) {
      masterRow.VRTOTALLANC = (compQtLanc.value || masterRow.QTLANCPROCESSA || 0) * masterRow.VRUNITLANC;
    }
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    //aqui logica para resto do PERCENT %
    let detailPropSum = 0;
    let smallerProp = false;
    gridDetail.datasource.data.forEach(row => {
      detailPropSum += row.PERCENT;
      if (!smallerProp || row.VRPROPVALOR < smallerProp.VRPROPVALOR)
        smallerProp = row;
    });
    //seta changed nas rows utilizando o campo PERCENT que nao é salvo
    if (!gridDetail.editing) gridDetail.editing = true;
    if (masterRow.__is_new) gridDetail.datasource.data.forEach((row) => {
      let tmpCopy = { ...row };
      tmpCopy.PERCENT = 'Z';
      gridDetail.updateRow(tmpCopy);
    });
    let difference = 0
    difference = 100 - parseFloat(detailPropSum.toFixed(2));
    if (difference < 0) {
      DialogService.show({
        name: 'error-dialog',
        type: 'error',
        title: 'Erro',
        text: 'Soma de % acima de 100%',
      });
    } else {
      return Http.post(gridMaster.datasource.route.concat('/save'), params).then((responseMaster) => {
        if (difference > 0) {
          let rowCopy = { ...smallerProp };
          rowCopy.QTITPROCESSA += (parseFloat((masterRow.QTTOTPROCESSA * parseFloat(difference.toFixed(2)) / 100).toFixed(5))) / rowCopy.VRPROPQUANTIDADE;
          rowCopy.PERCENT += difference;
          gridDetail.updateRow(rowCopy);
        }

        const changedRowsDetail = gridDetail.getEditedRows();
        const isDataSetDetail = changedRowsDetail.length > 1;
        changedRowsDetail.forEach((row) => {
          this.detailCalculableFields({ row });
          row.changed = true;
          if (masterRow.__is_new) {
            row.__is_new = true;
            row.NRLANCPROCESSA = responseMaster.data.data.NRLANCPROCESSA;
          }
          if (!row.NRLANCPROCESSA)
            row.NRLANCPROCESSA = masterRow.NRLANCPROCESSA;
        });
        const paramsDetail = isDataSetDetail ? changedRowsDetail : changedRowsDetail[0];
        Http.post(gridDetail.datasource.route.concat('/save'), paramsDetail).then((responseDetail) => {
          gridDetail.reload();
          if (gridDetail.editing) this.defaultState(gridDetail);
        });

        gridMaster.reload();
        if (gridMaster.editing) this.defaultState(gridMaster);
      });
    }

  }

  public setNewCodeField(dataSet) {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    if (this.paramsNewCode && this.paramsNewCode.__is_new_code) {
      dataSet.forEach((row) => {
        row.__using_unit = this.paramsNewCode.__using_unit || false;
        row.__new_code_pk = this.paramsNewCode.__new_code_pk;
        row.__table_pk = this.paramsNewCode.__table_pk;
        row.__new_code_interval = this.paramsNewCode.__new_code_interval || 1;
        row.__new_code_length = this.paramsNewCode.__new_code_length || 5;
        row.__new_code_column_size = this.paramsNewCode.__new_code_column_size || 10;
        row.__cast_number = this.paramsNewCode.__cast_number || false;
        if (!row.__columns_to_return && this.paramsNewCode && this.paramsNewCode.__columns_to_return)
          row.__columns_to_return = this.paramsNewCode.__columns_to_return;
      });
    }
  }

  public saveAllChanges() {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    this.saveGrid(gridDetail);
    this.saveGrid(gridMaster);
  }

  public defaultState(grid: GridEditable) {
    this.newRow = false;
    grid.cancelEditedRows();
  }

  public returnGrid(component: IDictionary) {
    let grid: IDictionary;
    if (component.type === 'button') grid = component.parent as IDictionary;
    else grid = component;
    return grid;
  }

  public addNewRow({ component }: any) {
    const grid: GridEditable = this.returnGrid(component) as GridEditable;
    const selectFilial = Metadata.getInstance<Select>('UNIDADE');
    const filialValue = selectFilial.value.CDFILIAL;
    const uniqueKey = grid.datasource.uniqueKey;
    const newUniqueKey = grid.datasource.data.length > 0 ? Number(grid.datasource.data[grid.datasource.data.length - 1][uniqueKey]) + 1 : 0;
    const defaultObjectToInsert = { __is_new: true, CDFILIAL: filialValue, [uniqueKey]: newUniqueKey };
    if (grid.name == 'produtosProcessados-detail')
      defaultObjectToInsert.NRLANCPROCESSA = this.masterCurrentRow.NRLANCPROCESSA;

    if (grid.name == 'produtosProcessados-master') {
      let date = this.paramFilialData.DTPROCESSA ? this.paramFilialData.DTPROCESSA : new Date().toLocaleDateString();
      defaultObjectToInsert.DTLANCPROCESSA = date;
    }

    grid.addNewRow(defaultObjectToInsert, 'start');
    //grid.reapplyConditions(defaultObjectToInsert);
  }

  public getFilterProdfili() {
    const selectFilial = Metadata.getInstance<Select>('UNIDADE');
    return selectFilial.value.CDFILIAL;
  }

  public deleteSelectedRows({ component }: any) {
    const grid: Grid = this.returnGrid(component) as GridEditable;
    const rowsTodelete = grid.selectedRows;
    return Http.delete(grid.datasource.route.concat('/delete'), { data: rowsTodelete }).then((response) => {
      if (response) {
        grid.reload();
      } else {
        grid.reload();
      }
      grid.selectedRows = [];
    });
  }

  public changeDetailVisibility(bool = false) {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    const detailCard = Metadata.getInstance<ZdCard>('produtoProcessado-detail-card');
    const resizeSize = 120;

    /* DESATIVADO TEMPORARIAMENTE ATÉ CORRIGIR ERRO DO ZH
     if (bool) {
      //this.masterToolbar = gridMaster.toolbarSlot;
      //gridMaster.toolbarSlot = [];

      this.masterHeight =  this.masterHeight? this.masterHeight : gridMaster.height.valueOf();
      gridMaster.height = resizeSize+'px';
      gridDetail.height = (parseInt(this.masterHeight) - resizeSize)+'px';
    } else {
      //gridMaster.toolbarSlot = this.masterToolbar.__ob__.dep.subs.length > 0 ? this.masterToolbar : gridMaster.toolbarSlot;
      gridMaster.height = this.masterHeight? this.masterHeight : gridMaster.height;
    } 
    */
    gridMaster.showFooter = !bool;
    detailCard.isVisible = bool;
    if (!bool) {
      gridDetail.datasource.filter.CDPRODUTO = '';
      gridDetail.datasource.filter.NRLANCPROCESSA = '';
      gridDetail.reload();
    }
  }

  public closeDetail() {
    const arrayGrids = [];
    arrayGrids.push(Metadata.getInstance<GridEditable>('produtosProcessados-master'));
    arrayGrids.push(Metadata.getInstance<GridEditable>('produtosProcessados-detail'));
    arrayGrids.forEach((grid) => {
      grid.newRow = false;
      grid.datasource.data = grid.datasource.data.filter((row) => !row.__is_new);
      grid.cancelEditedRows();
      grid.datasource.currentRow = {};
    });
    this.changeDetailVisibility(false);
  }

  public onChangeCurrentRow({ component }: IEventParam<Datasource>) {
    if (component.currentRow && component.currentRow.__ob__.dep.subs.length > 0) {
      this.changeDetailVisibility(true);
    } else {
      this.changeDetailVisibility(false);
    }

    if (component.currentRow !== this.masterCurrentRow) {
      const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
      const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
      const masterRow = gridMaster.datasource.currentRow;
      this.masterCurrentRow = component.currentRow;
      gridDetail.datasource.filter.NRLANCPROCESSA = component.currentRow.NRLANCPROCESSA || '';
      if (masterRow && masterRow.hasOwnProperty('__is_new') && masterRow.__is_new) {
        gridDetail.datasource.filter.NRLANCPROCESSA = '';
      }

      gridDetail.datasource.filter.CDPRODUTO = component.currentRow.CDPRODUTO;
      const fieldPropQuant = gridDetail.columns.filter(column => column.name === 'VRPROPQUANTIDADE')[0];
      fieldPropQuant.label = 'Proporcao ' + (masterRow.SGUNIDADE || '') + ' - ' + (masterRow.SGUNIDADEESTO || '');

      if (gridDetail.datasource.filter.CDPRODUTO) {
        gridDetail.reload().then((rows) => {
          if (rows) {
            const column = gridDetail.getColumn('PERCENT');
            rows.map((row, rowIdx) => {
              this.detailCalculableFields({ row });
            });
            setTimeout(() => {
              this.calculateDetailCost();
            }, 0);
          }
        });
      }
    }
  }

  public onChangeProduto({ component }: IEventParam<Datasource>) {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    //const selectFilial = Metadata.getInstance<Select>('UNIDADE');
    const idutilalmox = this.paramFilialData.IDUTILALMOX;
    const idutillcestq = this.paramFilialData.IDUTILLCESTQ;
    const masterRow = gridMaster.datasource.currentRow;
    let validateLenght = 0;
    try {
      validateLenght = component.currentRow.__ob__.dep.subs.length;
    } catch (err) {
      validateLenght = 0;
    }
    if (masterRow.__is_new && component.currentRow && component.currentRow !== this.selectProdutoCurrentRow && validateLenght > 0) {
      const compQtLanc = gridMaster.getComponent(masterRow.NRLANCPROCESSA, 'QTLANCPROCESSA');
	  const compDtLancProc = gridMaster.getComponent(masterRow.NRLANCPROCESSA, 'DTLANCPROCESSA');
      this.selectProdutoCurrentRow = component.currentRow;
      masterRow.CDPRODUTO = component.currentRow.CDPRODUTO ? component.currentRow.CDPRODUTO : '';
      masterRow.CDPRODESTO = component.currentRow.CDPRODESTO ? component.currentRow.CDPRODESTO : '';
      masterRow.SGUNIDADE = component.currentRow.SGUNIDADE ? component.currentRow.SGUNIDADE : '';
      masterRow.SGUNIDADEESTO = component.currentRow.SGUNIDADEESTO ? component.currentRow.SGUNIDADEESTO : '';
      masterRow.QTLANCPROCESSA = masterRow.QTLANCPROCESSA ?? (compQtLanc.value ?? 0);
	  masterRow.DTLANCPROCESSA = compDtLancProc.value?? masterRow.QTLANCPROCESSA;
      masterRow.CDMOXPRODSERPROC = idutilalmox != 'N' ? (component.currentRow.CDMOXPRODSERPROC ? component.currentRow.CDMOXPRODSERPROC : (this.paramFilialData.CDALMOXARIFE ?? ' ')) : ' ';
      masterRow.CDLOCPRODSERPROC = idutillcestq != 'N' ? (component.currentRow.CDLOCPRODSERPROC ? component.currentRow.CDLOCPRODSERPROC : (this.paramFilialData.CDLOCALESTOQ ?? ' ')) : ' ';
      masterRow.VRFATOCONV = component.currentRow.VRFATOCONV;
      this.getProductCost(component.currentRow.CDPRODESTO, masterRow.CDFILIAL, masterRow.DTLANCPROCESSA, masterRow.CDMOXPRODSERPROC, masterRow.CDLOCPRODSERPROC).then(productCost => {

        masterRow.QTTOTPROCESSA = (compQtLanc.value || masterRow.QTLANCPROCESSA || 0) * component.currentRow.VRFATOCONV;
        compQtLanc.addValidation('max', {
          limit: productCost.QTESTOQDIA,
          message: `${productCost.QTESTOQDIA} em estoque`,
        });
        masterRow.VRUNITLANC = productCost.VRCUSTOPROD * masterRow.VRFATOCONV;
        masterRow.VRTOTALLANC = (compQtLanc.value || masterRow.QTLANCPROCESSA || 0) * masterRow.VRUNITLANC;
        gridMaster.reapplyConditions(masterRow);
      });

      gridDetail.datasource.filter.CDPRODUTO = component.currentRow.CDPRODUTO ? component.currentRow.CDPRODUTO : '';
      gridDetail.datasource.filter.NRLANCPROCESSA = '';
      if (gridDetail.datasource.filter.CDPRODUTO) {
        const column = gridDetail.getColumn('PERCENT');
        gridDetail.reload().then((rows) => {
          if (rows) {
            rows.map((row, rowIdx) => {
              this.detailCalculableFields({ row });
            });
          }
          setTimeout(() => {
            this.calculateDetailCost();
          }, 0);
        });
      }
    }
  }

  public validationsAndTotal({ component }: IEventParam) {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    const masterRow = gridMaster.datasource.currentRow;
    masterRow.QTLANCPROCESSA = component.value ?? 0;
    if (masterRow.CDPRODUTO && (!masterRow.QTESTOQDIA || !masterRow.VRUNITLANC)) {
      this.getProductCost(masterRow.CDPRODESTO, masterRow.CDFILIAL, masterRow.DTLANCPROCESSA, (masterRow.CDMOXPRODSERPROC || ' '), (masterRow.CDLOCPRODSERPROC || ' ')).then(productCost => {
        masterRow.QTESTOQDIA = productCost.QTESTOQDIA;
        component.addValidation('max', {
          limit: productCost.QTESTOQDIA,
          message: `${productCost.QTESTOQDIA} em estoque`,
        });
        masterRow.VRUNITLANC = productCost.VRCUSTOPROD * masterRow.VRFATOCONV;
        masterRow.VRTOTALLANC = component.value * masterRow.VRUNITLANC || 0;
        masterRow.QTTOTPROCESSA = component.value * masterRow.VRFATOCONV || 0;
        gridMaster.reapplyConditions(masterRow);
      });
    } else {
      masterRow.VRTOTALLANC = component.value * masterRow.VRUNITLANC || 0;
      masterRow.QTTOTPROCESSA = component.value * masterRow.VRFATOCONV || 0;
      gridMaster.reapplyConditions(masterRow);
    }
    gridDetail.datasource.data.forEach((detailRow) => {
      gridDetail.reapplyConditions(detailRow);
    });
  }

  public validationsAndTotal2({ component, element, event }: IEventParam) {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const masterRow = gridMaster.datasource.currentRow;
    this.getProductCost(masterRow.CDPRODESTO, masterRow.CDFILIAL, masterRow.DTLANCPROCESSA, masterRow.CDMOXPRODSERPROC, masterRow.CDLOCPRODSERPROC).then(productCost => {
      masterRow.VRUNITLANC = productCost.VRCUSTOPROD * masterRow.VRFATOCONV;
      component.validations.max.limit = productCost.QTESTOQDIA;
      component.validations.max.message = productCost + ' em estoque';
      masterRow.VRTOTALLANC = component.value * masterRow.VRUNITLANC;
    });
  }

  public getProductCost(produto, filial = 'FILIAL_LOGADA', dtLancamento = new Date().toLocaleDateString(), almoxarifado = ' ', localEstoque = ' ', lote = 'SEMLOTE', subLote = ' ', tipoCusto = '03') {
    const row = {};
    row.CDFILIAL = filial;
    row.CDTIPOCUST = tipoCusto;
    row.CDPRODUTO = produto;
    row.CDALMOXARIFE = almoxarifado;
    row.CDLOCALESTOQ = localEstoque;
    row.NRLOTE = lote;
    row.NRSUBLOTE = subLote;
    row.DTLANCAMENTO = dtLancamento;

    return Http.post('/validacoes_estoque/consulta_custo', { requestType: 'Row', row }).then((response) => {
      return response.data.dataset.consultaCustoQuantidadeProduto;
    })
  }

  public detailCalculableFields({ row, component }) {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    const masterRow = gridMaster.datasource.currentRow;
    const qtTotMaster = masterRow.QTTOTPROCESSA;
    row.QTITPROCESSA = component ? component.value : (row.QTITPROCESSA || 0);
    const qtCalc = row.QTITPROCESSA * row.VRPROPQUANTIDADE;
    row.PERCENT = (qtCalc * 100) / qtTotMaster;
    row.PERCENT = isNaN(row.PERCENT) ? 0 : row.PERCENT;
    parseFloat(row.PERCENT).toFixed(3);
    if (!isNaN(qtTotMaster * (row.PERCENT / 100))) {
      row.percentCalc = qtTotMaster * (row.PERCENT / 100);
      let dataRow = gridDetail.datasource.data.filter((dataSetRow) => dataSetRow.NRSEQIT == row.NRSEQIT)[0];
      dataRow.percentCalc = qtTotMaster * (row.PERCENT / 100);
      dataRow.QTITPROCESSA = row.QTITPROCESSA;
      gridDetail.reapplyConditions(row);
    }
    this.calculateDetailCost(row);
  }

  public calculateDetailCost(rowParam = null) {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const masterRow = gridMaster.datasource.currentRow;
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    const datasetDetail = gridDetail.datasource.data;
    //const qtTotMaster = masterRow.QTLANCPROCESSA * masterRow.VRFATOCONV;
    const qtTotMaster = masterRow.QTTOTPROCESSA;
    let divPropValor = 0;
    datasetDetail.forEach(row => {
      divPropValor += (row.percentCalc || 0) * (row.VRPROPVALOR || 0);
    });
    masterRow.VRFATOCONVVAL = (qtTotMaster || 1) / (divPropValor || 1); // Fator de conversao calculado
    datasetDetail.map(row => {
      row.VRUNITITPROCESSA = ((masterRow.QTLANCPROCESSA / (qtTotMaster / masterRow.VRUNITLANC)) * row.VRPROPVALOR * masterRow.VRFATOCONVVAL) || 0;
      row.VRUNITITPROCESSA = parseFloat(((row.VRUNITITPROCESSA * row.VRPROPQUANTIDADE) || 0).toFixed(5));
      row.VRTOTITPROCESSA = parseFloat(((row.VRUNITITPROCESSA * row.QTITPROCESSA) || 0).toFixed(5));
      if (!!rowParam && rowParam.CDPRODUTO == row.CDPRODUTO) {
        rowParam.VRUNITITPROCESSA = row.VRUNITITPROCESSA;
        rowParam.VRTOTITPROCESSA = row.VRTOTITPROCESSA;
      }
    });
  }

  get maxProductInStock() {
    return this.selectProdutoCurrentRow.QTESTOQDIA || 0;
  }

  get gridMasterEditing() {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    return gridMaster.editing;
  }

  get gridMasterNotEditing() {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    return !gridMaster.editing;
  }

  get gridMasterCheckedbox(): boolean {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    return !(gridMaster.selectedRows.length > 0);
  }

  get deleteButtonDisabled(): boolean {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const checkdBox = gridMaster.selectedRows.length > 0;
    if (checkdBox) {
      const hasLanctoStock = gridMaster.selectedRows.some((row) => !!row.NRLANCESTQENTR);
      return hasLanctoStock;
    } else {
      return !checkdBox;
    }
  }

  get stockButtonsDisabled(): boolean {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const oneChecked = gridMaster.selectedRows.length == 1;
    if (oneChecked) {
      return gridMaster.selectedRows[0].NRLANCESTQENTR ? true : false;
    } else {
      return true;
    }
  }

  get stockButtonsNotDisabled(): boolean {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const oneChecked = gridMaster.selectedRows.length == 1;
    if (oneChecked) {
      return !gridMaster.selectedRows[0].NRLANCESTQENTR ? true : false;
    } else {
      return true;
    }
  }

  get gridDetailEditing() {
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    return gridDetail.editing;
  }

  get gridDetailNotEditing() {
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    return !gridDetail.editing;
  }

  get gridsNotEditing() {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const selectFilial = Metadata.getInstance<Select>('UNIDADE');
    try {
      const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
      this.detailStatus.editing = gridDetail.editing;
    } catch (err) {
      null;
    }

    selectFilial.disabled = !(!gridMaster.editing && !this.detailStatus.editing);
    return !gridMaster.editing && !this.detailStatus.editing;
  }

  get gridsEditing() {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    try {
      const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
      this.detailStatus.editing = gridDetail.editing;
    } catch (err) {
      null;
    }

    return gridMaster.editing || this.detailStatus.editing;
  }

  get gridDetailCheckedbox(): boolean {
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    return !(gridDetail.selectedRows.length > 0);
  }

  get gridDetailIsVisible(): boolean {
    const detail = Metadata.getInstance<GridEditable>('produtoProcessado-detail-card');
    return detail.isVisible;
  }

  public dontHasLanctoStock({ row }) {
    let boolHasLanctoStock = false;
    try {
      boolHasLanctoStock = row.NRLANCESTQENTR || this.masterCurrentRow.NRLANCESTQENTR ? true : false;
    } catch {
      boolHasLanctoStock = false;
    }
    return !boolHasLanctoStock;
  }

  public validateAbleToEditDetail({ row }) {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const gridDetail = Metadata.getInstance<GridEditable>('produtosProcessados-detail');
    const dontHasLanctoStock = this.dontHasLanctoStock({ row });
    return dontHasLanctoStock && gridMaster.isGridValid();
  }

  public masterHasLanctoStock({ row }) {
    return row.NRLANCESTQENTR || this.masterCurrentRow.NRLANCESTQENTR ? false : true;
  }

  public masterProductLimit() {
    if (this.masterCurrentRow.NRLANCPROCESSA) {
      const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
      const masterRow = gridMaster.datasource.currentRow;
      return this.getProductCost(masterRow.CDPRODESTO, masterRow.CDFILIAL, masterRow.DTLANCPROCESSA, masterRow.CDMOXPRODSERPROC, masterRow.CDLOCPRODSERPROC).then(productCost => {
        return productCost.QTESTOQDIA;
      });
    } else {
      return 0;
    }
  }

  public percentMask({ row }) {
    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const masterRow = gridMaster.datasource.currentRow;
    const qtCalc = ((row.QTITPROCESSA || 0) * row.VRPROPQUANTIDADE).toFixed(2);
    const unidadeMed = masterRow.SGUNIDADEESTO || '';
    return `${qtCalc} ${unidadeMed} `;
  }

  public prodEstoUnid({ row, column }) {
    return row.SGUNIDADEESTO;
    //column.componentProps.mask.suffixText = row.SGUNIDADEESTO;
    //const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    //const masterRow = gridMaster.datasource.currentRow;
    //const compQttot = gridMaster.getComponent(masterRow.NRLANCPROCESSA, 'QTTOTPROCESSA');
  }

  public saveStock({ component }: IDictionary) {
    const gridMaster = this.returnGrid(component) as GridEditable;
    let checkedRowsMaster = gridMaster.selectedRows;
    const isDataSetMaster = checkedRowsMaster.length > 1;
    const params = isDataSetMaster ? checkedRowsMaster : checkedRowsMaster[0];

    LoadingService.show('Realizando Lançamentos de Estoque');
    Http.post('/saveProdprocessaStock', params).then((responseStock) => {
      LoadingService.hide()
      if (!!responseStock.data.error) {
        DialogService.show({
          name: 'error-dialog',
          type: 'error',
          title: 'Erro',
          text: responseStock.data.error[0].errorMessage,
        });
      } else {
        const response = responseStock.data.data;
        const uk = gridMaster.datasource.uniqueKey;
        gridMaster.datasource.data.forEach((row) => {
          response.forEach((resp) => {
            if (resp[uk] == row[uk]) {
              row.NRLANCESTQENTR = resp.NRLANCESTQENTR;
              row.NRLANCESTQSAID = resp.NRLANCESTQSAID;
            }
          });
        });
        checkedRowsMaster = [];
      }
    });
  }

  public deleteStock({ component }: IDictionary) {
    const gridMaster = this.returnGrid(component) as GridEditable;
    let checkedRowsMaster = gridMaster.selectedRows;
    const isDataSetMaster = checkedRowsMaster.length > 1;
    const params = isDataSetMaster ? checkedRowsMaster : checkedRowsMaster[0];

    LoadingService.show('Deletando Lançamentos de Estoque');
    Http.post('/deleteProdprocessaStock', params).then((responseStock) => {
      LoadingService.hide()
      if (!!responseStock.data.error) {
        DialogService.show({
          name: 'error-dialog',
          type: 'error',
          title: 'Erro',
          text: responseStock.data.error[0].errorMessage,
        });
      } else {
        if (responseStock.status == 200) {
          checkedRowsMaster.forEach((row) => {
            row.NRLANCESTQENTR = null;
            row.NRLANCESTQSAID = null;
          });
          checkedRowsMaster = [];
        }
      }
    }).catch((error) => {
      let errorMessage = error.response ? error.response.data.error : error.message;
      DialogService.show({
        name: 'error-dialog',
        type: 'error',
        title: 'Erro',
        text: errorMessage,
      });
    });
  }

  public async createRetiradaUsageModal() {
    this.retiradaModal = await ModalService.createFromJson('components/processaProdutoModal', true);
  }

  public destroyRetiradaUsageModal() {
    this.retiradaModal?.destroy();
  }

  public openRetiradaModal() {
    this.retiradaModal.show();
  }

  public closeRetiradaModal() {
    this.retiradaModal.hide();
  }

  public selectCheckBox({ component }: any) {
    const retiradabutton = component.getChildInstance('retiradaButton');

    //retiradabutton.disabled = component.selectedRows.length != 0 ? false : true;

    const itemsText = component.selectedRows.map((item: any) => item.id);
  }

  public withdrawalOfStock({ component }) {
    const form = Metadata.getInstance<Form>('retiradaForm');
    if (!form.validate()) return;

    const gridMaster = Metadata.getInstance<GridEditable>('produtosProcessados-master');
    const currentRow = component.parent.parent.value;

    gridMaster.selectedRows.map((row: any) => {
      row.CDCENTCUST = currentRow.NMSETOR.CDCENTCUST;
      row.CDSETOR = currentRow.NMSETOR.CDSETOR;
      row.CDTIPORETI = currentRow.NMTIPORETI.CDTIPORETI;
      row.DSLANCESTQ = currentRow.DSLANCESTQ;
    });

    LoadingService.show('Realizando retirada de Estoque');
    Http.post('/saveProdprocessaStock', gridMaster.selectedRows).then((response) => {
      this.retiradaModal.hide();
      gridMaster.reload();
      LoadingService.hide();
    });
  }
}